using System;
using System.Collections.Generic;
using System.Text;

namespace NoJavaLibrary.Game.Scripts
{
    /// <summary>
    /// GameObjectɓnꂽXNvgǂ
    /// </summary>
    abstract class ScriptReader : IScriptReader
    {
        #region ϐ
        IGameObject owner;
        ScriptSender sender;
        #endregion

        #region Cxg
        /// <summary>
        /// ownerXNvg󂯎Ƃ
        /// </summary>
        public event ScriptEventHandler ScriptCatch;
        /// <summary>
        /// qɃXNvg𑗂Ƃ
        /// </summary>
        public event ScriptEventHandler ScriptSend;
        /// <summary>
        /// łƂ
        /// </summary>
        public event DiscreatingEventHandler Discreating;
        #endregion

        public ScriptReader(IGameObject owner)
        {
            this.owner = owner;
            sender = new ScriptSender(this, owner);
        }

        #region ֐
        protected abstract void TranslateScript(Script sendScript);

        #region Cxgnho^
        /// <summary>
        /// ownerɑ΂ăCxgnho^
        /// </summary>
        void RegisterOwnerEventHandler()
        {
            owner.ScriptCatch += new ScriptEventHandler(owner_ScriptCatch);
            owner.Discreating += new DiscreatingEventHandler(owner_Discreating);
        }

        /// <summary>
        /// ownerɑ΂ẴCxgnh폜
        /// </summary>
        void DisregisterOwnerEventHandler()
        {
            owner.ScriptCatch -= new ScriptEventHandler(owner_ScriptCatch);
            owner.Discreating -= new DiscreatingEventHandler(owner_Discreating);
        }

        /// <summary>
        /// seaderɑ΂ăCxgnho^
        /// </summary>
        void RegisterSeaderEventHandler()
        {
            sender.ChildScriptSend += new ScriptEventHandler(sender_ChildScriptSend);
            sender.OwnerScriptSend += new ScriptEventHandler(sender_OwnerScriptSend);
        }

        /// <summary>
        /// seaderɑ΂ẴCxgnh폜
        /// </summary>
        void DisregisterSenderEventHandler()
        {
            sender.ChildScriptSend -= new ScriptEventHandler(sender_ChildScriptSend);
            sender.OwnerScriptSend -= new ScriptEventHandler(sender_OwnerScriptSend);
        }
        #endregion

        /// <summary>
        /// ł
        /// </summary>
        protected virtual void Discreate()
        {
            Discreating();
            DisregisterSenderEventHandler();
            DisregisterOwnerEventHandler();
        }
        #endregion

        #region Cxgnh
        void owner_ScriptCatch(Script sendScript)
        {
            ScriptCatch(sendScript);
        }

        void owner_Discreating()
        {
            Discreate();
        }

        void sender_ChildScriptSend(Script sendScript)
        {
            ScriptSend(sendScript);
        }

        void sender_OwnerScriptSend(Script sendScript)
        {
            TranslateScript(sendScript);
        }
        #endregion
    }
}
